Bug 95265 - Blender: error: field/array has incomplete type
Summary: Blender: error: field/array has incomplete type
Status: RESOLVED WONTFIX
Alias: None
Product: Beignet
Classification: Unclassified
Component: Beignet (show other bugs)
Version: unspecified
Hardware: Other All
: medium normal
Assignee: Edward O'Callaghan
QA Contact:
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2016-05-04 16:35 UTC by Sven Arvidsson
Modified: 2016-08-28 04:08 UTC (History)
0 users

See Also:
i915 platform:
i915 features:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Sven Arvidsson 2016-05-04 16:35:52 UTC
I get these errors when trying to use the OpenCL renderer in Blender:

Compiling OpenCL kernel ...
Build flags: -D__NODES_MAX_GROUP__=0 -D__NODES_FEATURES__=0 -D__MAX_CLOSURE__=1 -D__NO_HAIR__ -D__NO_OBJECT_MOTION__ -D__NO_CAMERA_MOTION__ -D__NO_BAKING__ -D__NO_SUBSURFACE__ -D__NO_BRANCHED_PATH__
OpenCL kernel build output:
stringInput.cl:20217:22: error: field has incomplete type 'struct PathRadiance'
stringInput.cl:20217:9: note: forward declaration of 'struct PathRadiance'
stringInput.cl:20222:23: error: array has incomplete element type 'struct PathRadiance'
stringInput.cl:20217:9: note: forward declaration of 'struct PathRadiance'

Blender 2.77, launched with CYCLES_OPENCL_SPLIT_KERNEL_TEST=1, Beignet 1.1.2, LLVM 3.6.2

Ivybridge Mobile
HD Graphics 4000
Comment 1 Sven Arvidsson 2016-05-05 15:24:39 UTC
Testing an older release, 2.76 I get this error:

stringInput.cl:2476:12: error: used type 'float' where floating point type is not allowed

I noticed that POCL (a CPU based implementation) give the same errors and warnings. So maybe these are problems with llvm or Blender?
Comment 2 Edward O'Callaghan 2016-08-23 04:35:11 UTC
Blender upstream issue can be found here^[1]. I also sent a minor fix to libclew which is needed for some folks so i'll include it here^[2].

This blocks Blender/Cycles from working with radeon using mesa/opencl currently.

Kind Regards,
Edward.

[1] - https://developer.blender.org/T46409

[2] - https://github.com/martijnberger/clew/pull/15/commits/03509308ecaa32bb348e68686642c0077afb08c5
Comment 3 Edward O'Callaghan 2016-08-28 04:05:01 UTC
Turns out this issue is actually within
Comment 4 Edward O'Callaghan 2016-08-28 04:08:20 UTC
Blender itself.

However, good luck getting anything sensible merged with them, they are too dumb to understand their own software and just wast time. Fixes needed are below:

https://developer.blender.org/D2171

https://developer.blender.org/T49144
https://developer.blender.org/rBf7322931471a3161ca32dc0ca47fe013d56cf566


Use of freedesktop.org services, including Bugzilla, is subject to our Code of Conduct. How we collect and use information is described in our Privacy Policy.